%{

enum SYMBOL {
      SAND,      SARRAY,     SBEGIN,     SBOOLEAN,    SCHAR,
      SDIVD,     SDO,        SELSE,      SEND,        SFALSE,
      SIF,       SINTEGER,   SMOD,       SNOT,        SOF,
      SOR,       SPROCEDURE, SPROGRAM,   SREADLN,     STHEN,
      STRUE,     SVAR,       SWHILE,     SWRITELN,    SEQUAL,
      SNOTEQUAL, SLESS,      SLESSEQUAL, SGREATEQUAL, SGREAT,
      SPLUS,     SMINUS,     SSTAR,      SLPAREN,     SRPAREN,
      SLBRACKET, SRBRACKET,  SSEMICOLON, SCOLON,      SRANGE,
      SASSIGN,   SCOMMA,     SDOT,       SIDENTIFIER, SCONSTANT,
      SSTRING,   SLBRACE,    SRBRACE,    SSQUOTE,     SPARA,
      SDIGIT,    SALPHA,     SEOF,       SNULL,       SERR
     };

FILE *outfile;

int lineno = 1;
int in_annotation = 0;
int in_string = 0;


%}
%%

[\t ]+ {if (in_string == 1) ECHO; };

and { if (in_string == 1) ECHO; else if (in_annotation!=1)
        fprintf(outfile,"%s\t SAND    \t %d\t %d\n", yytext, SAND, lineno);}
array { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SARRAY  \t %d\t %d\n", yytext, SARRAY, lineno);}
begin { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SBEGIN  \t %d\t %d\n", yytext, SBEGIN, lineno);}
boolean { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SBOOLEAN\t %d\t %d\n", yytext, SBOOLEAN, lineno);}
char { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SCHAR   \t %d\t %d\n", yytext, SCHAR, lineno);}

div|"/" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SDIVD   \t %d\t %d\n", yytext, SDIVD, lineno);}
do { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SDO     \t %d\t %d\n", yytext, SDO, lineno);}
else { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SELSE   \t %d\t %d\n", yytext, SELSE, lineno);}
end { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SEND    \t %d\t %d\n", yytext, SEND, lineno);}
false { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SFALSE  \t %d\t %d\n", yytext, SFALSE, lineno);}

if { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SIF     \t %d\t %d\n", yytext, SIF, lineno);}
integer { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SINTEGER\t %d\t %d\n", yytext, SINTEGER, lineno);}
mod { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SMOD    \t %d\t %d\n", yytext, SMOD, lineno);}
not { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SNOT    \t %d\t %d\n", yytext, SNOT, lineno);}
of { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SOF     \t %d\t %d\n", yytext, SOF, lineno);}

or { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SOR     \t %d\t %d\n", yytext, SOR, lineno);}
procedure { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SPROCEDURE\t %d\t %d\n", yytext, SPROCEDURE, lineno);}
program { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SPROGRAM\t %d\t %d\n", yytext, SPROGRAM, lineno);}
readln { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SREADLN \t %d\t %d\n", yytext, SREADLN, lineno);}
then { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t STHEN   \t %d\t %d\n", yytext, STHEN, lineno);}

true { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t STRUE   \t %d\t %d\n", yytext, STRUE, lineno);}
var { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SVAR    \t %d\t %d\n", yytext, SVAR, lineno);}
while { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SWHILE  \t %d\t %d\n", yytext, SWHILE, lineno);}
writeln { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SWRITELN\t %d\t %d\n", yytext, SWRITELN, lineno);}
"=" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SEQUAL  \t %d\t %d\n", yytext, SEQUAL, lineno);}

"<>" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SNOTEQUAL\t %d\t %d\n", yytext, SNOTEQUAL, lineno);}
"<" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SLESS   \t %d\t %d\n", yytext, SLESS, lineno);}
"<=" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SLESSEQUAL\t %d\t %d\n", yytext, SLESSEQUAL, lineno);}
">=" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SGREATEQUAL\t %d\t %d\n", yytext, SGREATEQUAL, lineno);}
">" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SGREAT  \t %d\t %d\n", yytext, SGREAT, lineno);}

"+" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SPLUS   \t %d\t %d\n", yytext, SPLUS, lineno);}
"-" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SMINUS  \t %d\t %d\n", yytext, SMINUS, lineno);}
"*" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SSTAR   \t %d\t %d\n", yytext, SSTAR, lineno);}
"(" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SLPAREN \t %d\t %d\n", yytext, SLPAREN, lineno);}
")" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SRPAREN \t %d\t %d\n", yytext, SRPAREN, lineno);}

"[" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SLBRACKET\t %d\t %d\n", yytext, SLBRACKET, lineno);}
"]" { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SRBRACKET\t %d\t %d\n", yytext, SRBRACKET, lineno);}
";" {if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SSEMICOLON\t %d\t %d\n", yytext, SSEMICOLON, lineno);}
":" {if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SCOLON  \t %d\t %d\n", yytext, SCOLON, lineno);}
".." {if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SRANGE  \t %d\t %d\n", yytext, SRANGE, lineno);}

":=" {if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SASSIGN \t %d\t %d\n", yytext, SASSIGN, lineno);}
"," {if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SCOMMA  \t %d\t %d\n", yytext, SCOMMA, lineno);}
"." {if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SDOT    \t %d\t %d\n", yytext, SDOT, lineno);}
[a-zA-Z][a-zA-Z0-9]* { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SIDENTIFIER\t %d\t %d\n", yytext, SIDENTIFIER, lineno);}
[0-9]* { if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SCONSTANT\t %d\t %d\n", yytext, SCONSTANT, lineno);}

"'" {if ((in_string != 1)&&(in_annotation !=1)) { in_string =1; ECHO;}
     else
     if (in_string==1){
          fprintf(outfile,"'\t SSTRING\t %d\t %d\n",SSTRING, lineno);
          in_string =0;
      }
    }

"{" {if (in_string == 1) ECHO; else in_annotation = 1;}
"}" {if (in_string == 1) ECHO; 
      else
    { if (in_annotation == 1) in_annotation = 0;
      else fprintf(outfile,"%s\t SERR   \t %d\t %d\n", yytext, SERR, lineno);}}
\n {if (in_string == 1) {
      fprintf(outfile,"\t SERR   \t %d\t %d\n", SERR, lineno);
      in_string = 0;
    }
    else lineno++; }
. {if (in_string == 1) ECHO; else if (in_annotation!=1)
         fprintf(outfile,"%s\t SERR   \t %d\t %d\n", yytext, SERR, lineno);}
%%

main(argc,argv)
int argc;
char **argv;
{
  char outputfilename[BUFSIZ];

  if (argc > 1) {
    FILE *infile; 
    int len;

    len = strlen(argv[1]);
    if((len < 5)||
       (argv[1][len-4] != '.')||(argv[1][len-3] != 'p')||
       (argv[1][len-2] != 'a')||(argv[1][len-1] != 's'))
      {
        fprintf(stderr, "file name is not adequate\n");
        exit(1);
      }
    strncpy(outputfilename,argv[1],len-3);
    outputfilename[len-3]='t';
    outputfilename[len-2]='s';
    outputfilename[len-1]=NULL;

    infile = fopen(argv[1], "r");
    outfile = fopen(outputfilename, "w");
    if ((!infile)||(!outfile)) {
      fprintf(stderr, "could not open file\n");
      exit(1);
    }
    yyin = infile; yyout = outfile; 
    yylex();
  }
  else
    {
      fprintf(stderr, "usage: scanner filename\n");
      exit(1);
    }
  exit(-1);
}
